'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _blacklist = require('./blacklist');

var _blacklist2 = _interopRequireDefault(_blacklist);

var _misc = require('./misc');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Links = function () {
    function Links(allowExternal, links, blackList) {
        _classCallCheck(this, Links);

        this.all = this.normalize(links);
        this.next = [];
        this.blackList = blackList ? new _blacklist2.default(blackList) : false;
        this.getLinksMethod = allowExternal ? this.getAllLinks : this.getInternalLinks;
    }

    _createClass(Links, [{
        key: 'filterNext',
        value: function filterNext(links) {
            var _this = this;

            return links.filter(function (link) {
                return _this.all.indexOf(link) == -1;
            });
        }
    }, {
        key: 'addForNext',
        value: function addForNext(links) {
            this.next = this.blackList ? this.blackList.filter(this.filterNext([].concat(_toConsumableArray(this.next), _toConsumableArray(links)))) : this.filterNext([].concat(_toConsumableArray(this.next), _toConsumableArray(links)));
        }
    }, {
        key: 'setAll',
        value: function setAll() {
            this.all = (0, _misc.uniq)([].concat(_toConsumableArray(this.all), _toConsumableArray(this.next)));
        }

        /**
         * Normalize urls without protocol.
         * @param {array} links 
         * @returns {array} urls with protocol.
         */

    }, {
        key: 'normalize',
        value: function normalize(links) {
            return links.map(function (link) {
                return link.match(/http:\/\/|https:\/\//g) ? link : 'http://' + link;
            });
        }

        /**
         * 
         * @param {string} url
         * @returns {array} url protocol, host, path
         * 
         * Exeption for broken links.
         * 
         */

    }, {
        key: 'getUrlProps',
        value: function getUrlProps(url) {
            try {
                var match = url.match(/^(http|https)?(?:[\:\/]*)([a-z0-9\.-]*)(?:\:([0-9]+))?(\/[^?#]*)?(?:\?([^#]*))?(?:#(.*))?$/i);

                return {
                    protocol: match[1],
                    host: match[2],
                    path: match[4]
                };
            } catch (error) {
                return {
                    protocol: null,
                    host: null,
                    path: null
                };
            }
        }
    }, {
        key: 'parse',
        value: function parse(content) {
            try {
                return content.match(new RegExp('<a(.*?)href=(((\'|").*?(\'|")))', 'gi')).join("\n").match(new RegExp('href=(((\'|").*?(\'|")))', 'gi')).map(function (item) {
                    return item.slice(6, -1);
                });
            } catch (error) {
                return [];
            }
        }
    }, {
        key: 'find',
        value: function find(url, content) {
            this.addForNext((0, _misc.uniq)(this.getLinksMethod(url, content)));
        }
    }, {
        key: 'getAllLinks',
        value: function getAllLinks(url, content) {
            var _this2 = this;

            var urlProps = this.getUrlProps(url),
                extractLinks = this.parse(content);

            return extractLinks.map(function (link) {
                if (link[0] == "/" && link[1] == "/") {
                    return link.slice(2);
                } else {
                    if (link[0] == "/") {
                        return urlProps.protocol + "://" + urlProps.host + link;
                    }

                    if (!_this2.getUrlProps(link).protocol) {
                        return urlProps.protocol + "://" + urlProps.host + "/" + link;
                    }
                }

                return link;
            });
        }
    }, {
        key: 'getInternalLinks',
        value: function getInternalLinks(url, content) {
            var _this3 = this;

            var urlProps = this.getUrlProps(url),
                extractLinks = this.parse(content);

            var filtered = extractLinks.filter(function (link) {
                if (link[0] == "/") {
                    return link;
                }

                if (urlProps.host === _this3.getUrlProps(link).host) {
                    return link;
                }
            });

            var next = filtered.map(function (link) {
                if (link[0] == "/") {
                    return urlProps.protocol + "://" + urlProps.host + link;
                }

                if (urlProps.host === _this3.getUrlProps(link).host) {
                    if (link[0] == "/" && link[1] == "/") {
                        return link.slice(2);
                    } else {
                        if (link[0] == "/") {
                            return urlProps.protocol + "://" + urlProps.host + link;
                        }

                        if (!_this3.getUrlProps(link).protocol) {
                            return urlProps.protocol + "://" + urlProps.host + "/" + link;
                        }
                    }

                    return link;
                }
            });

            return next;
        }
    }]);

    return Links;
}();

exports.default = Links;