'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _settings = require('./constants/settings');

var _settings2 = _interopRequireDefault(_settings);

var _links = require('./links');

var _links2 = _interopRequireDefault(_links);

var _pool = require('./pool');

var _pool2 = _interopRequireDefault(_pool);

var _misc = require('./misc');

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _puppeteer = require('puppeteer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Crawlefier = function () {
    function Crawlefier() {
        var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _settings2.default;
        var blackList = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

        _classCallCheck(this, Crawlefier);

        this.settings = {
            timeout: settings.timeout,
            external: settings.external,
            blackList: blackList,
            userAgent: settings.userAgent,
            headlessChrome: settings.headlessChrome,
            depth: {
                current: 0,
                max: settings.depth
            }
        };

        this.counter = {
            all: 0,
            done: 0
        };

        this.pool = new _pool2.default(settings.threads);
        this.getRequestMethod = settings.headlessChrome ? this.puppeteerRequest : this.axiosRequest;
    }

    _createClass(Crawlefier, [{
        key: 'setCallbacks',
        value: function setCallbacks(onSuccess, onError) {
            if (onSuccess) this.onSuccessCallback = onSuccess;
            if (onError) this.onErrorCallback = onError;
        }
    }, {
        key: 'launch',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(links, onSuccess, onError) {
                var _this = this;

                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                if (!(!links || !links.length)) {
                                    _context.next = 2;
                                    break;
                                }

                                throw new Error('No links!');

                            case 2:

                                this.links = new _links2.default(this.settings.external, links, this.settings.blackList);
                                this.setCallbacks(onSuccess, onError);

                                if (!this.settings.headlessChrome) {
                                    _context.next = 8;
                                    break;
                                }

                                _context.next = 7;
                                return (0, _puppeteer.launch)();

                            case 7:
                                this.headlessChrome = _context.sent;

                            case 8:
                                return _context.abrupt('return', new Promise(function (resolve, reject) {
                                    _this.reject = reject;
                                    _this.resolve = resolve;
                                    _this.crawl(_this.links.all);
                                }));

                            case 9:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function launch(_x3, _x4, _x5) {
                return _ref.apply(this, arguments);
            }

            return launch;
        }()
    }, {
        key: 'crawl',
        value: function crawl(links) {
            var _this2 = this;

            if (links.length > 0) {
                this.settings.depth.current++;
                this.links.next = [];
                this.counter.done = 0;
                this.counter.all = links.length;

                links.forEach(function (link) {
                    return _this2.pool.addTask(_this2.getRequestMethod.bind(_this2, link));
                });

                this.pool.run();
            } else {
                this.resolve(this.links.all);
            }
        }
    }, {
        key: 'isDone',
        value: function isDone() {
            return this.counter.done == this.counter.all;
        }
    }, {
        key: 'isCloudflare',
        value: function isCloudflare(content) {
            if (content.match(new RegExp('cloudflare', 'gi'))) {
                return true;
            }
        }
    }, {
        key: 'onSuccess',
        value: function onSuccess(url, content) {
            this.links.find(url, content);
            this.update();

            if (this.onSuccessCallback) {
                this.onSuccessCallback({ url: url, content: content });
            }
        }
    }, {
        key: 'onError',
        value: function onError(url, error) {
            this.update();

            if (this.onErrorCallback) {
                this.onErrorCallback({ url: url, message: error });
            }
        }

        /**
         *@param {string} url crawl url
         *@param {function} next sets next callback in pool queue
         */

    }, {
        key: 'puppeteerRequest',
        value: function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(url, next) {
                var page, content;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                _context2.prev = 0;
                                _context2.next = 3;
                                return this.headlessChrome.newPage();

                            case 3:
                                page = _context2.sent;
                                _context2.next = 6;
                                return page.setUserAgent(this.settings.userAgent);

                            case 6:
                                _context2.next = 8;
                                return page.goto(url, { timeout: this.settings.timeout });

                            case 8:
                                _context2.next = 10;
                                return page.content();

                            case 10:
                                content = _context2.sent;

                                if (!this.isCloudflare(content)) {
                                    _context2.next = 17;
                                    break;
                                }

                                _context2.next = 14;
                                return (0, _misc.wait)(7500);

                            case 14:
                                _context2.next = 16;
                                return page.content();

                            case 16:
                                content = _context2.sent;

                            case 17:

                                this.onSuccess(url, content);
                                _context2.next = 20;
                                return page.close();

                            case 20:
                                next();
                                _context2.next = 27;
                                break;

                            case 23:
                                _context2.prev = 23;
                                _context2.t0 = _context2['catch'](0);

                                this.onError(url, _context2.t0);
                                next();

                            case 27:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this, [[0, 23]]);
            }));

            function puppeteerRequest(_x6, _x7) {
                return _ref2.apply(this, arguments);
            }

            return puppeteerRequest;
        }()

        /**
         *@param {string} url crawl url
         *@param {function} next sets next callback in pool queue
         */

    }, {
        key: 'axiosRequest',
        value: function () {
            var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(url, next) {
                var req;
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                _context3.prev = 0;
                                _context3.next = 3;
                                return _axios2.default.get(url, { timeout: this.settings.timeout, responseType: 'text', userAgent: this.settings.userAgent });

                            case 3:
                                req = _context3.sent;

                                this.onSuccess(url, req.data);
                                next();
                                _context3.next = 12;
                                break;

                            case 8:
                                _context3.prev = 8;
                                _context3.t0 = _context3['catch'](0);

                                this.onError(url, _context3.t0);
                                next();

                            case 12:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this, [[0, 8]]);
            }));

            function axiosRequest(_x8, _x9) {
                return _ref3.apply(this, arguments);
            }

            return axiosRequest;
        }()
    }, {
        key: 'update',
        value: function update() {
            this.counter.done++;

            if (this.isDone()) {
                if (this.settings.depth.current < this.settings.depth.max) {
                    this.links.setAll();
                    this.crawl(this.links.next);
                } else {
                    if (this.settings.headlessChrome) {
                        this.headlessChrome.close();
                    }

                    this.resolve(this.links.all);
                }
            }
        }
    }]);

    return Crawlefier;
}();

exports.default = Crawlefier;